<template>
  <b-button
    variant="primary"
    v-b-modal.set-user-groups-modal
    v-if="me && me.groups.includes('ADMIN')"
  >
    <b-icon-pencil />
    Set groups

    <b-modal
      id="set-user-groups-modal"
      :title="`Set grups for ${user.name}`"
      @ok="submit"
    >
      <p v-show="error" style="color: red">
        Something went wrong, please double-check your input or try it later
        again. Error message: {{ error }}
      </p>

      <b-form>
        <label for="group">Group</label>
        <b-form-radio-group
          id="group"
          v-model="group"
          :options="[
            { text: 'ADMIN', value: 'ADMIN' },
            { text: 'MOD', value: 'MOD' },
            { text: 'REPORTER', value: 'REPORTER' }
          ]"
        />
      </b-form>
    </b-modal>
  </b-button>
</template>

<script>
import gql from "graphql-tag";

export default {
  name: "SetUserGroups",
  data() {
    return {
      me: {
        groups: []
      },
      error: "",
      name: this.user.name || "",
      group: this.getGroup(this.user.groups)
    };
  },
  apollo: {
    me: {
      query: gql`
        query {
          me {
            id
            name
            groups
            email
            joined
          }
        }
      `
    }
  },
  props: {
    user: Object
  },
  methods: {
    getGroup(groups) {
      return groups.includes("ADMIN")
        ? "ADMIN"
        : groups.includes("MOD")
        ? "MOD"
        : "REPORTER";
    },
    getGroups(group) {
      switch (group) {
        case "ADMIN":
          return ["ADMIN", "MOD", "REPORTER"];
        case "MOD":
          return ["MOD", "REPORTER"];
        default:
          return ["REPORTER"];
      }
    },
    submit(e) {
      e.preventDefault();
      this.$apollo
        .mutate({
          mutation: gql`
            mutation($id: ID!, $groups: [Group!]!) {
              setUserGroups(id: $id, groups: $groups) {
                id
              }
            }
          `,
          variables: {
            id: this.user.id,
            groups: this.getGroups(this.group)
          }
        })
        .then(() => location.reload())
        .catch(error => {
          this.error = error;
        });
    }
  }
};
</script>
